/*** MACRO pvals is called at the end of MARO MAXTEST4 ***/;
%macro pvals(statement1=, statement2=);
data pval_for_single(keep=locus_no p_val);
	set norms(&statement1) end=last;
	retain num_p 0 f11 f21 f31 f12 f22 f32  f13 f23 f33 eigen_val3 locus_no;
	if _n_=1 then do;
		eigen_val3=symget('_eigen_val3_');
		locus_no=input(trim(left(symget('_locus_no_'))), best8.);
	end;
	if eigen_val3=0 then do;
		if _n_=1 then do;
			f11=symget('f11'); f12=symget('f12');
			f21=symget('f21'); f22=symget('f22');
			f31=symget('f31'); f32=symget('f32');
		end;
		n1b=f11*n1+f12*n2;
		n2b=f21*n1+f22*n2;
		n3b=f31*n1+f32*n2;
	end; /* end: if eigen_val3=0 then do; */
	else do;
		if _n_=1 then do;
			f11=symget('f11'); f12=symget('f12'); f13=symget('f13');
			f21=symget('f21'); f22=symget('f22'); f23=symget('f23');
			f31=symget('f31'); f32=symget('f32'); f33=symget('f33');
		end;
		n1b=f11*n1+f12*n2+f13*n3;
		n2b=f21*n1+f22*n2+f23*n3;
		n3b=f31*n1+f32*n2+f33*n3;
	end; /* end: if eigen_val3=0 then do; ...; else do;...*/
	max_abs_new=max(abs(n1b), abs(n2b), abs(n3b)); 
	if(max_abs_new>=&_max_abs_zs_) then num_p=num_p+1;
	if last then do;
		num_p=num_p+&_num_p_;
		p_val=num_p/(&statement2);
		call symput('_p_val_', p_val);
		call symput('_num_p_', num_p);
		output;
	end; /* end: if last then do */
	run;
%mend; /* End of MACRO pvals */
